#pragma hdrstop

#include "LanGameLib.h"

// 
char AdapterName[MAX_PATH + 4];
//ip 
char IpAddress[4 * 4];
//  
char ApplicationPath[MAX_PATH];
// 
char HostName[MAX_PATH];

static char _ga_addr[MAX_PATH];
//   
char * GA(char * addr)
{
  memset(_ga_addr, 0, MAX_PATH);
  memcpy(_ga_addr, addr, strcspn(addr, ":"));
  return _ga_addr;
}

//  
u_short GP(char * addr)
{
  size_t length;

  length = strcspn(addr, ":");
  if (strlen(addr) != length)
    return (u_short)atoi(addr + length + 1);
  return 0;
}

// addr->s_addr .. www.ya.ru->u_int
bool get_s_addr( char *addr, unsigned int *ps_addr )
{
  struct hostent *hp;

  if ((*ps_addr = inet_addr(addr)) != INADDR_NONE) return true;

  if((hp = gethostbyname(addr)) != NULL)
  {
     *ps_addr = (( struct in_addr * )hp->h_addr)->s_addr;
     return true;
  }

  return false;
}



//   WSA
char * WSAErrorToStr(int error)
{
   switch (error)
   {
    case WSANOTINITIALISED : return "A successful WSAStartup must occur before using this function.";
    case WSAENETDOWN :       return "The network subsystem has failed.";
    case WSAEACCES :         return "The requested address is a broadcast address, but the appropriate flag was not set.";
    case WSAEINVAL:          return "An unknown flag was specified, or MSG_OOB was specified for a socket with SO_OOBINLINE enabled.";
    case WSAEINTR :          return "The (blocking) call was canceled through WSACancelBlockingCall.";
    case WSAEINPROGRESS:     return "A blocking Windows Sockets 1.1 call is in progress, or the service provider is still processing a callback function.";
    case WSAEFAULT:          return "The buf or to parameters are not part of the user address space, or the tolen argument is too small.";
    case WSAENETRESET :      return "The connection has been broken due to the remote host resetting.";
    case WSAENOBUFS :        return "No buffer space is available.";
    case WSAENOTCONN :       return "The socket is not connected (connection-oriented sockets only)";
    case WSAENOTSOCK:        return "The descriptor is not a socket.";
    case WSAEOPNOTSUPP:      return "MSG_OOB was specified, but the socket is not stream style such as type SOCK_STREAM, out-of-band data is not supported in the communication domain associated with this socket, or the socket is unidirectional and supports only receive operations.";
    case WSAESHUTDOWN :      return "The socket has been shut down; it is not possible to sendto on a socket after shutdown has been invoked with how set to SD_SEND or SD_BOTH.";
    case WSAEWOULDBLOCK	:    return "The socket is marked as nonblocking and the requested operation would block.";
    case WSAEMSGSIZE :       return "The socket is message oriented, and the message is larger than the maximum supported by the underlying transport.";
    case WSAEHOSTUNREACH :   return "The remote host cannot be reached from this host at this time.";
    case WSAECONNABORTED :   return "The virtual circuit was terminated due to a time-out or other failure. The application should close the socket as it is no longer usable.";
    case WSAECONNRESET :     return "The virtual circuit was reset by the remote side executing a 'hard' or 'abortive' close. For UPD sockets, the remote host was unable to deliver a previously sent UDP datagram and responded with a 'Port Unreachable' ICMP packet. The application should close the socket as it is no longer usable.";
    case WSAEADDRNOTAVAIL:   return "The specified address is not available from the local machine.";
    case WSAEAFNOSUPPORT :   return "Addresses in the specified family cannot be used with this socket.";
    case WSAEDESTADDRREQ :   return "A destination address is required.";
    case WSAENETUNREACH	:    return "The network cannot be reached from this host at this time.";
    case WSAETIMEDOUT :      return "A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond.";
   }
   return "Unknown";
}

#include <stdio.h>
//  SOCKET_ERROR
bool WSACheck(int Value, char *Params)
{
#ifdef _DEBUG
  char str[MAX_PATH];

  if (Value == SOCKET_ERROR)
  {
     strcpy(str, WSAErrorToStr(WSAGetLastError()));
     if (Params) { strcat(str, " "); strcat(str, Params); }
     MessageBox(0, str, "WSAError", 0);
  }
#endif
  return Value != SOCKET_ERROR;
}

//   
bool Test(void)
{
  struct sockaddr_in peer;
  SOCKET udp_test_socket;
  u_int use_own_header = 1;

  //  
  udp_test_socket = socket( AF_INET, SOCK_DGRAM, 0 );
  if (udp_test_socket == INVALID_SOCKET)
  {
#ifdef _DEBUG
    MessageBox(0, "Can't open udp_test_socket", "Error", 0);
#endif
    return false;
  }


  // :   
  if (!WSACheck(setsockopt(udp_test_socket, SOL_SOCKET, SO_BROADCAST, (char *)&use_own_header, sizeof(use_own_header)),
                "Error setsockopt udp_test_socket"))
  {
    closesocket(udp_test_socket);
    return false;
  }
  memset(&peer, 0, sizeof(sockaddr_in));
  peer.sin_addr.s_addr = INADDR_BROADCAST; //255.255.255.255
  peer.sin_family = AF_INET;
  peer.sin_port = htons(27015); //CS :)
  //  UDP 
  if (!WSACheck(sendto( udp_test_socket, TEST_MESSAGE, sizeof(TEST_MESSAGE), 0, ( struct sockaddr * )&peer, sizeof( peer ) ),
                "Can't sendto udp_test_socket"))
  {
    closesocket(udp_test_socket);
    return false;
  }
  closesocket(udp_test_socket);
  return true;
}

#include <iphlpapi.h>
// ip 
bool GetIpAddress(char *AdapterName, DWORD Context, char *IpAddress)
{
  PIP_ADAPTER_INFO pAdapterInfo, pAdapt;
  PIP_ADDR_STRING chAddr;

  int iErr;
  ULONG iAdapterInfo = 0;

  iErr = GetAdaptersInfo(NULL, &iAdapterInfo);
  if ((iErr!= 0) && (iErr != ERROR_BUFFER_OVERFLOW))
  {
#ifdef _DEBUG
    MessageBox(0, "Can't get Adapters info", "Error", 0);
#endif
    return false;
  }
  if ((pAdapterInfo = (PIP_ADAPTER_INFO) GlobalAlloc(GPTR, iAdapterInfo)) == NULL)
  {
#ifdef _DEBUG
    MessageBox(0, "Memory allocation error", "Error", 0);
#endif
    return false;
  }
  if (GetAdaptersInfo(pAdapterInfo, &iAdapterInfo) != 0)
  {
#ifdef _DEBUG
    MessageBox(0, "Can't get Adapters info", "Error", 0);
#endif
    GlobalFree(pAdapterInfo);
    return false;
  }
  if (pAdapterInfo == NULL)
  {
#ifdef _DEBUG
    MessageBox(0, "Adapters not found", "Error", 0);
#endif
    GlobalFree(pAdapterInfo);
    return false;
  }

  for (pAdapt = pAdapterInfo; pAdapt; pAdapt=pAdapt->Next)
    if ( strcmp(pAdapt->AdapterName, AdapterName) == 0 )
      for( chAddr = &pAdapt->IpAddressList; chAddr; chAddr = chAddr->Next )
        if (chAddr->Context == Context)
        {

          memcpy(IpAddress, &chAddr->IpAddress, sizeof(IP_ADDRESS_STRING));
          GlobalFree(pAdapterInfo);
          return true;
        }

  GlobalFree(pAdapterInfo);
  return false;
}

#pragma pack(push, 1)
#include "ipv4.h"
// UDP   RAW 
int SendRawUDP(SOCKET RAWSocket, u_long daddr, u_short dport,
                                 u_long saddr, u_short sport,
                                 const char FAR *buf, int len)
{
  int rc;
  struct sockaddr_in peer;

  char *buff = (char *)GlobalAlloc(GPTR, 28 + len);
  memset(buff, 0, 28 + len);
  ip_header *iphdr = (ip_header *)buff;
  udp_header *udphdr =   (udp_header *)(buff + 20);

  iphdr->ver_ihl = 0x45;
  iphdr->tos = 0;
  iphdr->tlen = htons(28 + len);
  iphdr->identification = (u_short)rand(); //random(65535); --  VS
  iphdr->flags_fo = 0;
  iphdr->ttl = 128;
  iphdr->proto = 0x11;
  iphdr->crc = 0;
  iphdr->saddr = saddr;
  iphdr->daddr = daddr;

  udphdr->sport = sport;
  udphdr->dport = dport;
  udphdr->len = htons(8 + len);
  udphdr->crc = 0;
  memcpy(buff + 28, buf, len);
  udphdr->crc = rs_pseudo_crc ((char *)udphdr, 8 + len, iphdr->saddr, iphdr->daddr, 8 + len, IPPROTO_UDP);


  memset( &peer, 0, sizeof(peer) );
  peer.sin_addr.s_addr = daddr;
  peer.sin_family = AF_INET;
  peer.sin_port = dport;

  rc = sendto( RAWSocket, buff, 28 + len, 0, ( struct sockaddr * )&peer, sizeof( peer ) );
  GlobalFree(buff);
  return rc;
}
#pragma pack(pop)

//     ListBox-
void LB_SetHrzScroll(HWND hLB)
{
  char str[MAX_PATH];
  HDC hLB_DC = GetDC(hLB);
  SIZE Size;
  LRESULT i, m = 0, count =  SendMessage (hLB,  LB_GETCOUNT, 0, 0);

  for (i=0; i < count; i++)
  {
   SendMessage (hLB,  LB_GETTEXT, i, (LPARAM)str); // 
   GetTextExtentPoint32(hLB_DC, str, (int)strlen(str), &Size); //    
   if (Size.cx > m) m = Size.cx;
  }

  ReleaseDC(hLB, hLB_DC); // DC
  SendMessage (hLB, LB_SETHORIZONTALEXTENT , m + 2, 0); //  
}

static char __ExtractFilePathStr[MAX_PATH];

//Returns the drive and directory portions of a file name
char * ExtractFilePath(char *FileName)
{
  size_t nLen;

  strcpy(__ExtractFilePathStr, FileName);
  nLen = strlen(__ExtractFilePathStr);
  while(__ExtractFilePathStr[nLen--] != '\\');
  __ExtractFilePathStr[nLen + 1] = '\0';
  return __ExtractFilePathStr;
}

//Returns the name of the program directory.
char * GetProgramDir(void)
{
  char str[MAX_PATH];

  GetModuleFileName(GetModuleHandle(NULL), str, MAX_PATH);
  return ExtractFilePath(str);
}


//     ListBox-
bool FindAdrInListBox(HWND hlb, char *addr)
{
  LRESULT i, count;
  char str[MAX_PATH];

  count =  SendMessage (hlb, LB_GETCOUNT, 0, 0); //. 
  for (i = 0; i < count; i++ )
  {
    if (SendMessage(hlb, LB_GETTEXT, i, (LPARAM)str) !=  LB_ERR)
      if (strcmp(addr, str) == 0) return true;   //   
  }
  return false;
}


//   ListBox
bool AddAdrToListBox(HWND hlb, char *addr)
{
  u_int ip_addr;

  if (strlen(GA(addr)) == 0) return false; // 
  if (strcmp( GA(addr), HostName) == 0) return false; //   
  if (FindAdrInListBox(hlb, addr)) return false;   //   

  if (!get_s_addr(GA(addr), &ip_addr)) return false; // 
  //   
  if ( (ip_addr == INADDR_BROADCAST) || (ip_addr == INADDR_LOOPBACK) || (ip_addr == 0x100007f) || (ip_addr == INADDR_ANY) ) return false;
  if (ip_addr == inet_addr(IpAddress)) return false; //   


  SendMessage(hlb, LB_ADDSTRING, 0, (LPARAM)addr); //   ListBox
  LB_SetHrzScroll(hlb); //  
  return true;
}

/*  
bool AddAdrsToListBox(HWND hlb, char *buf)
{
  size_t i = 0;
  bool result = false;

  while(buf[i] != '\0\0')
  {
    result = AddAdrToListBox(hlb, buf + i);
    i += strlen(buf + i) + 1;
  }
  return result;
}
*/

bool DelAdrFromListBox(HWND hlb, char *addr)
{
  LRESULT i, count;
  char str[MAX_PATH];

  count =  SendMessage(hlb, LB_GETCOUNT, 0, 0); // -   
  for (i = 0; i < count; i++)
  {
    if (SendMessage(hlb, LB_GETTEXT, i, (LPARAM)str) ==  LB_ERR) continue; //   
    if ( strcmp(str, addr) == 0 )
    {
      SendMessage(hlb, LB_DELETESTRING, i, 0); //
      return true;
    }
  }
  return false;
}

//./.   
BOOL EnableIcon(bool b_Show, PNOTIFYICONDATA pIcd)
{
  BOOL bSuccess;

  //
  if (b_Show)
  {
     pIcd->uFlags = NIF_ICON |NIF_TIP|NIF_MESSAGE;
     bSuccess = Shell_NotifyIcon(NIM_ADD, pIcd);
  }
  //.
  else
  {
     pIcd->uFlags = NIF_ICON|NIF_MESSAGE;
     bSuccess = Shell_NotifyIcon(NIM_DELETE, pIcd);
  }
  return bSuccess;
}

