//---------------------------------------------------------------------------
//LanGame   API - sendto, WSASendto.
//       hook-
//  -
//    :
//http://forum.sources.ru/index.php?showtopic=84355&view=findpost&p=643096
//http://www.wasm.ru/article.php?article=apihook_1 , AdwareBox
//---------------------------------------------------------------------------
#pragma hdrstop
#include "LanGameApi.h"
#pragma pack(push, 1)
// IPv4
#include "..\ipv4.h"
// 
#include "..\LanGameLib.h"



#define MAX_BUFFER_SZ 0xFFFF
//#define INTERCEPT_SENDTO 1
//#define INTERCEPT_WSASENDTO 2



//    
struct TLogData
{
  u_long saddr;
  u_long daddr;
  u_short sport;
  u_short dport;
  int len;
  char buf[MAX_BUFFER_SZ];
};

typedef BOOL WINAPI hook(HWND Wnd);
typedef BOOL WINAPI unhook(void);
hook *phook;
unhook *punhook;

LRESULT CALLBACK LanGameApiWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

static HWND hl;
static SOCKET RAW_socket = INVALID_SOCKET;
bool hooked = false;
HMODULE hLib = NULL;
static bool Work;

static HWND hWnd = NULL;


bool StartLanGameApi(HWND hlb)
{
  WNDCLASS wc;
  u_int use_own_header = 1; //     

  hl = hlb;

  if (!hLib)
    hLib = LoadLibrary("lgapi32.dll");
  if (!hLib)
  {
#ifdef _DEBUG
    MessageBox(0, "Can't load 'lgapi32.dll'", "Error", 0);
#endif
    return false;
  }
  phook = (hook *)GetProcAddress(hLib, "hook");
  if (!phook)
  {
#ifdef _DEBUG
    MessageBox(0, "Can't load 'hook' address", "Error", 0);
#endif
    StopLanGameApi();
    return false;
  }
  punhook = (unhook *)GetProcAddress(hLib, "unhook");
  if (!punhook)
  {
#ifdef _DEBUG
    MessageBox(0, "Can't load 'unhook' address", "Error", 0);
#endif
    StopLanGameApi();
    return false;
  }

  //  
  memset(&wc, 0 , sizeof(WNDCLASS) );
  wc.lpfnWndProc = (WNDPROC)LanGameApiWndProc;
  wc.hInstance = GetModuleHandle(NULL);
  wc.lpszClassName = "LanGameApiWnd";
  if ( !RegisterClass(&wc) )
  {
#ifdef _DEBUG
    MessageBox(0, "Can't register class 'LanGameApiWnd'", "Error", 0);
#endif
    StopLanGameApi();
    return false;
  }
  //  
  hWnd = CreateWindow(
		  "LanGameApiWnd", //
		  "", //
		  0,
		  0, // X
		  0, // Y
		  0, //
		  0, //
		  hlb, // -
		  NULL, // 
		  wc.hInstance, // 
		  NULL); //  ,    WM_CREATE
  //    
  if (!hWnd)
  {
#ifdef _DEBUG
    MessageBox(0, "Can't create window 'LanGameApiWnd'", "Error", 0);
#endif
    StopLanGameApi();
    return false;
  }

  if (RAW_socket == INVALID_SOCKET)
  {
    // raw 
    RAW_socket = socket(AF_INET, SOCK_RAW, IPPROTO_IP);
    if (RAW_socket == INVALID_SOCKET)
    {
#ifdef _DEBUG
       MessageBox(0, "Can't open RAW_socket", "Error", 0);
#endif
       StopLanGameApi();
       return false;
    }
    //   RAW,   
    if (!WSACheck(setsockopt (RAW_socket, IPPROTO_IP, 2, (char*)&use_own_header, sizeof(use_own_header)),
        "Can't set option RAW for RAW_socket"))
    {
      StopLanGameApi();
      return false;
    }
  }//if (!RAW_socket)

  hooked = phook(hWnd);
  if (!hooked)
  {
#ifdef _DEBUG
    MessageBox(0, "Can't run 'hook' procedure", "Error", 0);
#endif
    StopLanGameApi();
    return false;
  }

  Work = false;
  if(!Test()) //  
  {
    StopLanGameApi();
    return false;
  }
  Sleep(200);

  if (!Work) StopLanGameApi();
  return Work;
}



LRESULT CALLBACK LanGameApiWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  struct TLogData *PLogData;
  LRESULT i, lbcount; //-   listbox
  char str[MAX_PATH];
  u_int daddr, saddr;
  u_short aport, dport;

  if (message == WM_COPYDATA)
  {
    PLogData = (struct TLogData *)((PCOPYDATASTRUCT)lParam)->lpData;

    if (strcmp(TEST_MESSAGE, PLogData->buf) == 0)
      { Work = true; return 0; } // 

    saddr = inet_addr(IpAddress);

    lbcount =  SendMessage (hl, LB_GETCOUNT, 0, 0); // -   
    for (i = 0; i < lbcount; i++)
    {
       if (SendMessage(hl, LB_GETTEXT, i, (LPARAM)str) ==  LB_ERR) continue; //   
       if (!get_s_addr(GA(str), &daddr)) continue; //   u_int
       aport = GP(str); //   
       if (aport) dport = htons(aport); else dport = PLogData->dport; //  0 ,   
       WSACheck(SendRawUDP(RAW_socket, daddr, dport, saddr, PLogData->sport, PLogData->buf, PLogData->len), "Can't sendto api raw_socket");
    }//for
    return 0;
  }//if
  return DefWindowProc(hWnd, message, wParam, lParam);
}

void StopLanGameApi(void)
{
  if (hooked)
  {
    if(!punhook())
    {
#ifdef _DEBUG
      MessageBox(0, "Can't run 'unhook' procedure", "Error", 0);
#endif
    }
    else hooked = false;
  }

  if (hLib)
  {
    FreeLibrary(hLib);
    hLib = NULL;
  }

  if (hWnd)
  {
    DestroyWindow(hWnd);
    hWnd = NULL;
  }

  UnregisterClass("LanGameApiWnd", GetModuleHandle(NULL));

  if (RAW_socket != INVALID_SOCKET)
  {
    closesocket(RAW_socket);
    RAW_socket = INVALID_SOCKET;
  }

}

#pragma pack(pop)






