//---------------------------------------------------------------------------
//-----------------------  IPv4 ------------------------------------
//---------------------------------------------------------------------------

#ifndef ipv4H
#define ipv4H

// IPv4 header
typedef struct _ip_header
{
  unsigned char	 ver_ihl;        // Version (4 bits) + Internet header length (4 bits)
  unsigned char	 tos;	         // Type of service
  unsigned short tlen;		 // Total length
  unsigned short identification; // Identification
  unsigned short flags_fo;	 // Flags (3 bits) + Fragment offset (13 bits)
  unsigned char	 ttl;		 // Time to live
  unsigned char	 proto;		 // Protocol
  unsigned short crc;		 // Header checksum
  unsigned int	 saddr;		 // Source address
  unsigned int	 daddr;		 // Destination address
  unsigned int	 op_pad;	 // Option + Padding
} ip_header;

// UDP header
typedef struct _udp_header
{
  unsigned short sport;	// Source port
  unsigned short dport;	// Destination port
  unsigned short len;  	// Datagram length
  unsigned short crc;  	// Checksum
} udp_header;

// TCP header
typedef struct _tcp_header
{
  unsigned short src_port; //  
  unsigned short dst_port; //  
  unsigned int   seq_n;    //  
  unsigned int   ack_n;    //  
  unsigned char  offset;   // 
  unsigned char  flags;    // 
  unsigned short win;      // 
  unsigned short crc ;     //   
  unsigned short urg_ptr ; //  
} tcp_header;

//       TCP  UDP
typedef struct _pseudo_header
{
  unsigned int   src_addr;
  unsigned int   dst_addr;
  unsigned char	 zero;
  unsigned char	 proto;
  unsigned short length;
} pseudo_header;

//    TCP  UDP
unsigned short rs_pseudo_crc (char * data, int data_length, unsigned int src_addr,
                              unsigned int dst_addr, int packet_length, unsigned char proto);


#endif
