//---------------------------------------------------------------------------
//LanGame  WinPcap.   packet.dll
//    :
//http://www.winpcap.org  WinPcap Documentation, WinPcap\Examples-remote\PacketDriver\TestPacketCapture
//http://cherepovets-city.ru/insecure/reading/papers/packet_dll.htm
//http://www.wasm.ru/article.php?article=apihook_3   
//---------------------------------------------------------------------------
#pragma hdrstop
#include "ldpacket.h"
//#include <packet32.h>
#include <ntddndis.h>
#include "LanGamePcap.h"
#pragma pack(push, 1)
// IPv4
#include "..\ipv4.h"
// Ethernet
#include "..\ether.h"
// 
#include "..\LanGameLib.h"

#define MAX_BUFFER_SZ  256000

static char buffer[MAX_BUFFER_SZ];  // buffer to hold the data coming from the driver
LPPACKET lpPacket = NULL;
LPADAPTER lpAdapter = NULL;

static bool MyThreadTerminated;
static HANDLE hMyThread = NULL;
static SOCKET RAW_socket = INVALID_SOCKET;
static bool Work;

static DWORD WINAPI MyThread(LPVOID lpParam)
{
  ULONG	ulBytesReceived;
  char *buf;
  unsigned int off, tlen;
  struct bpf_hdr *hdr;
  LRESULT i, lbcount; //-   listbox
  char str[MAX_PATH];
  u_int daddr, saddr;
  u_short aport, dport;
  HWND hl;
  ether_header *ethhdr;
  ip_header *iphdr;
  udp_header *udphdr;

  hl = (HWND)lpParam;

  while (!MyThreadTerminated)
  {

    if (PacketReceivePacket(lpAdapter, lpPacket, TRUE) == TRUE)
    {

      ulBytesReceived = lpPacket->ulBytesReceived;
      buf = (char *)lpPacket->Buffer;
      off = 0;
      while(off < ulBytesReceived)
      {
        hdr=(struct bpf_hdr *)(buf + off);
	tlen = hdr->bh_caplen;
	off += hdr->bh_hdrlen;
        if (tlen < 14) goto resume; // Ethernet
        ethhdr = (ether_header *)(buf + off);
        if (ethhdr->type != htons(0x0800)) goto resume; // IP
        if (tlen - 14 < 20) goto resume;
        iphdr = (ip_header *)(buf + off + 14);
        if (iphdr->proto != IPPROTO_UDP) goto resume; // UDP
        if (iphdr->daddr != INADDR_BROADCAST) goto resume; // 
        if (tlen - 34 < 8) goto resume;
        udphdr = (udp_header *) (buf + off + 34);

        if (strcmp(TEST_MESSAGE, buf + off + 42) == 0)
         { Work = true; goto resume; } // 

        saddr = inet_addr(IpAddress);

        lbcount =  SendMessage (hl, LB_GETCOUNT, 0, 0); // -   
        for (i = 0; i < lbcount; i++)
        {
          if (SendMessage(hl, LB_GETTEXT, i, (LPARAM)str) ==  LB_ERR) continue; //   
          if (!get_s_addr(GA(str), &daddr)) continue; //   u_int
          aport = GP(str); //   
          if (aport) dport = htons(aport); else dport = udphdr->dport; //  0 ,   
          WSACheck(SendRawUDP(RAW_socket, daddr, dport, saddr, udphdr->sport,
                     buf + off + 42, tlen - 42), "Can't sendto pcap raw_socket");
        }//for


resume: off = Packet_WORDALIGN(off + tlen);
      }//while
    } //if
#ifdef _DEBUG
    else MessageBox(0, "PacketReceivePacket failed", "Error", 0);
#endif
  }
  return 0;
}

HMODULE hpacket = NULL;
SC_HANDLE hSCManager = NULL, hService = NULL;
#define SERVICE_NAME "npf"
#define DISPLAY_NAME "NetGroup Packet Filter Driver"

bool StartLanGamePcap(HWND hlb)
{
  char str[MAX_PATH], s[MAX_PATH];
  DWORD dThread;
  u_int use_own_header = 1; //     

  //.
  hpacket = LoadLibrary("packet.dll");
  if ( hpacket == NULL)
  {
    strcpy(str, ApplicationPath); //    
    strcat(str, "\\WinPcap");
    GetCurrentDirectory(MAX_PATH, s);
    SetCurrentDirectory(str);
    strcat(str, "\\packet.dll");
    hpacket = LoadLibrary(str);
    SetCurrentDirectory(s);

    if ( hpacket == NULL)
    {
#ifdef _DEBUG
      MessageBox(NULL, "Can't load 'packet.dll'", "Error", 0 );
#endif
      StopLanGamePcap();
      return false;
    }

    hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
    if (hSCManager == NULL)
    {
#ifdef _DEBUG
       MessageBox(NULL, "Can't open SC Manager", "Error", 0 );
#endif
       StopLanGamePcap();
       return false;
    }

    //    ?
    hService = OpenService(hSCManager, SERVICE_NAME, SERVICE_ALL_ACCESS);
    //     
    if (hService && StartService(hService, 0, NULL))
    {
      CloseServiceHandle(hService); // handle
      hService = NULL; //    
    }
    else
    {
      if (hService) DeleteService(hService); //     

      // 
      strcpy(str, ApplicationPath); //    
      strcat(str, "\\WinPcap\\npf.sys");
      hService = CreateService(hSCManager, SERVICE_NAME, DISPLAY_NAME, SERVICE_ALL_ACCESS,
                               SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START, SERVICE_ERROR_NORMAL,
                               str, NULL, NULL, NULL, NULL, NULL);
      if (!hService)
      {  //       
#ifdef _DEBUG
         MessageBox(NULL, "Can't open driver 'npf.sys'", "Error", 0 );
#endif
         StopLanGamePcap();
         return false;
      }
    }

    if (!StartService(hService, 0, NULL)) // 
    {  //     
       DeleteService(hService);
       CloseServiceHandle(hService); // handle
       hService = NULL;
#ifdef _DEBUG
       MessageBox(NULL, "Can't start driver 'npf.sys'", "Error", 0 );
#endif
       StopLanGamePcap();
       return false;
    }

  } //if ( hpacket == NULL)


  // 
  if ( !init_packet_dll(hpacket) )
  {
    StopLanGamePcap();
    return false;
  }

  // 
  strcpy(str, "\\Device\\NPF_");
  strcat(str, AdapterName);
  lpAdapter = PacketOpenAdapter(str);
  if (!lpAdapter || (lpAdapter->hFile == INVALID_HANDLE_VALUE))
  {
#ifdef _DEBUG
      MessageBox(0, "Unable to open the adapter", "Error", 0);
#endif
      StopLanGamePcap();
      return false;
  }

  // set the network adapter in broadcast mode
  if (PacketSetHwFilter(lpAdapter, NDIS_PACKET_TYPE_BROADCAST)==FALSE)
  {
#ifdef _DEBUG
    MessageBox(0, "Unable to set broadcast mode", "Error", 0);
#endif
    StopLanGamePcap();
    return false;
  }

  // set a 512K buffer in the driver
  if (PacketSetBuff(lpAdapter, 512000)==FALSE)
  {
#ifdef _DEBUG
    MessageBox(0, "Unable to set the kernel buffer", "Error", 0);
#endif
    StopLanGamePcap();
    return false;
  }

   // set a 1 second read timeout
  if (PacketSetReadTimeout(lpAdapter, 1000)==FALSE)
  {
#ifdef _DEBUG
    MessageBox(0, "Unable to set the read tiemout", "Error", 0);
#endif
    StopLanGamePcap();
    return false;
  }

  //allocate and initialize a packet structure that will be used to
  //receive the packets.
  if ((lpPacket = PacketAllocatePacket())==NULL)
  {
#ifdef _DEBUG
    MessageBox(0, "Failed to allocate the LPPACKET structure", "Error", 0);
#endif
    StopLanGamePcap();
    return false;
  }

  //allocate a packet buffer
  PacketInitPacket(lpPacket,(char*)buffer, MAX_BUFFER_SZ);

  if (RAW_socket == INVALID_SOCKET)
  {
    // raw 
    RAW_socket = socket(AF_INET, SOCK_RAW, IPPROTO_IP);
    if (RAW_socket == INVALID_SOCKET)
    {
#ifdef _DEBUG
       MessageBox(0, "Can't open RAW_socket", "Error", 0);
#endif
       StopLanGamePcap();
       return false;
    }
    //   RAW,   
    if (!WSACheck(setsockopt (RAW_socket, IPPROTO_IP, 2, (char*)&use_own_header, sizeof(use_own_header)),
        "Can't set option RAW for RAW_socket"))
    {
      StopLanGamePcap();
      return false;
    }
  }//if (!RAW_socket)


  MyThreadTerminated = false;
  if (!hMyThread)
  { // 
    hMyThread = CreateThread(NULL, 0, MyThread, (LPVOID)hlb, 0, &dThread);
    if (!hMyThread) //   , 
    {
      StopLanGamePcap();
      return false;
    }
  }

  Work = false;
  if(!Test()) //  
  {
    StopLanGamePcap();
    return false;
  }
  Sleep(200);

  if (!Work) StopLanGamePcap();
  return Work;

}

void StopLanGamePcap(void)
{
  DWORD lpExitCode;
  SERVICE_STATUS ServiceStatus;

  // 
  MyThreadTerminated = true;
  if (hMyThread)
  {
    // 5  ?
    if ( WaitForSingleObject(hMyThread, 5000) != 0 )
    {
      //   thread,  
      GetExitCodeThread(hMyThread, &lpExitCode);
      TerminateThread(hMyThread, lpExitCode);
      WaitForSingleObject(hMyThread, 5000);
    }
    CloseHandle(hMyThread);
    hMyThread = NULL;
  }

  //free a packet buffer
  if (lpPacket)
  {
    PacketFreePacket(lpPacket);
    lpPacket = NULL;
  }

  // close the adapter and exit
  if (lpAdapter)
  {
    PacketCloseAdapter(lpAdapter);
    lpAdapter = NULL;
  }

  //  
  if (RAW_socket != INVALID_SOCKET)
  {
    closesocket(RAW_socket);
    RAW_socket = INVALID_SOCKET;
  }

  // 
  if (hpacket)
  {
    FreeLibrary(hpacket);
    hpacket = NULL;
  }

  //   
  if (hService)
  {
    ControlService(hService, SERVICE_CONTROL_STOP, &ServiceStatus);
    DeleteService(hService);
    CloseServiceHandle(hService); // handle
    hService = NULL;
  }

  // 
  if (hSCManager)
  {
    CloseServiceHandle(hSCManager);
    hSCManager = NULL;
  }

}

#pragma pack(pop)

