//---------------------------------------------------------------------------


#pragma hdrstop

#include "ldpacket.h"

//---------------------------------------------------------------------------


typedef BOOLEAN tPacketGetAdapterNames(PTSTR pStr,PULONG  BufferSize);
tPacketGetAdapterNames *pPacketGetAdapterNames;

BOOLEAN PacketGetAdapterNames(PTSTR pStr,PULONG  BufferSize)
{
   return (*pPacketGetAdapterNames)(pStr, BufferSize);
}

typedef LPADAPTER tPacketOpenAdapter(PCHAR AdapterName);
tPacketOpenAdapter *pPacketOpenAdapter;

LPADAPTER PacketOpenAdapter(PCHAR AdapterName)
{
   return (*pPacketOpenAdapter)(AdapterName);
}

typedef VOID tPacketCloseAdapter(LPADAPTER lpAdapter);
tPacketCloseAdapter *pPacketCloseAdapter;

VOID PacketCloseAdapter(LPADAPTER lpAdapter)
{
   return (*pPacketCloseAdapter)(lpAdapter);
}

typedef LPPACKET tPacketAllocatePacket(void);
tPacketAllocatePacket *pPacketAllocatePacket;

LPPACKET PacketAllocatePacket(void)
{
  return (*pPacketAllocatePacket)();
}

typedef VOID tPacketInitPacket(LPPACKET lpPacket,PVOID  Buffer,UINT  Length);
tPacketInitPacket *pPacketInitPacket;

VOID PacketInitPacket(LPPACKET lpPacket,PVOID  Buffer,UINT  Length)
{
  (*pPacketInitPacket)(lpPacket, Buffer, Length);
}

typedef VOID tPacketFreePacket(LPPACKET lpPacket);
tPacketFreePacket *pPacketFreePacket;

VOID PacketFreePacket(LPPACKET lpPacket)
{
  (*pPacketFreePacket)(lpPacket);
}
typedef BOOLEAN tPacketReceivePacket(LPADAPTER AdapterObject,LPPACKET lpPacket,BOOLEAN Sync);
tPacketReceivePacket *pPacketReceivePacket;

BOOLEAN PacketReceivePacket(LPADAPTER AdapterObject,LPPACKET lpPacket,BOOLEAN Sync)
{
  return(*pPacketReceivePacket)(AdapterObject, lpPacket, Sync);
}

typedef BOOLEAN tPacketSendPacket(LPADAPTER AdapterObject,LPPACKET pPacket,BOOLEAN Sync);
tPacketSendPacket *pPacketSendPacket;

BOOLEAN PacketSendPacket(LPADAPTER AdapterObject,LPPACKET pPacket,BOOLEAN Sync)
{
  return (*pPacketSendPacket)(AdapterObject, pPacket, Sync);
}

typedef BOOLEAN tPacketSetHwFilter(LPADAPTER AdapterObject,ULONG Filter);
tPacketSetHwFilter *pPacketSetHwFilter;

BOOLEAN PacketSetHwFilter(LPADAPTER AdapterObject,ULONG Filter)
{
  return (*pPacketSetHwFilter)(AdapterObject, Filter);
}

typedef BOOLEAN tPacketRequest(LPADAPTER  AdapterObject,BOOLEAN Set,PPACKET_OID_DATA  OidData);
tPacketRequest *pPacketRequest;

BOOLEAN PacketRequest(LPADAPTER  AdapterObject,BOOLEAN Set,PPACKET_OID_DATA  OidData)
{
  return (*pPacketRequest)(AdapterObject, Set, OidData);
}

typedef BOOLEAN tPacketSetBuff(LPADAPTER AdapterObject,int dim);
tPacketSetBuff *pPacketSetBuff;

BOOLEAN PacketSetBuff(LPADAPTER AdapterObject,int dim)
{
  return (*pPacketSetBuff)(AdapterObject, dim);
}

typedef BOOLEAN tPacketSetBpf(LPADAPTER AdapterObject,struct bpf_program *fp);
tPacketSetBpf *pPacketSetBpf;

BOOLEAN PacketSetBpf(LPADAPTER AdapterObject,struct bpf_program *fp)
{
  return (*pPacketSetBpf)(AdapterObject, fp);
}

typedef BOOLEAN tPacketGetStats(LPADAPTER AdapterObject,struct bpf_stat *s);
tPacketGetStats *pPacketGetStats;

BOOLEAN PacketGetStats(LPADAPTER AdapterObject,struct bpf_stat *s)
{
  return (*pPacketGetStats)(AdapterObject, s);
}

typedef BOOLEAN tPacketGetNetType(LPADAPTER AdapterObject,NetType *type);
tPacketGetNetType *pPacketGetNetType;

BOOLEAN PacketGetNetType (LPADAPTER AdapterObject,NetType *type)
{
  return (*pPacketGetNetType)(AdapterObject, type);
}

typedef BOOLEAN tPacketSetReadTimeout(LPADAPTER AdapterObject,int timeout);
tPacketSetReadTimeout *pPacketSetReadTimeout;

BOOLEAN PacketSetReadTimeout(LPADAPTER AdapterObject,int timeout)
{
  return (*pPacketSetReadTimeout)(AdapterObject, timeout);
}

typedef BOOLEAN tPacketSetMode(LPADAPTER AdapterObject,int mode);
tPacketSetMode *pPacketSetMode;

BOOLEAN PacketSetMode(LPADAPTER AdapterObject,int mode)
{
  return (*pPacketSetMode)(AdapterObject, mode);
}

typedef BOOLEAN tPacketSetNumWrites(LPADAPTER AdapterObject,int nwrites);
tPacketSetNumWrites *pPacketSetNumWrites;

BOOLEAN PacketSetNumWrites(LPADAPTER AdapterObject,int nwrites)
{
  return (*pPacketSetNumWrites)(AdapterObject, nwrites);
}

bool init_packet_dll(HMODULE hpacket)
{
   pPacketGetAdapterNames = (tPacketGetAdapterNames*) GetProcAddress(hpacket, "PacketGetAdapterNames");
   if (pPacketGetAdapterNames == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketGetAdapterNames", "Error", MB_OK );
#endif
     return false;
   }
   pPacketOpenAdapter = (tPacketOpenAdapter*) GetProcAddress(hpacket, "PacketOpenAdapter");
   if (pPacketOpenAdapter == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketOpenAdapter", "Error", MB_OK );
#endif
     return false;
   }
   pPacketCloseAdapter = (tPacketCloseAdapter*) GetProcAddress(hpacket, "PacketCloseAdapter");
   if (pPacketCloseAdapter == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketCloseAdapter", "Error", MB_OK );
#endif
     return false;
   }
   pPacketAllocatePacket = (tPacketAllocatePacket*) GetProcAddress(hpacket, "PacketAllocatePacket");
   if (pPacketAllocatePacket == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketAllocatePacket", "Error", MB_OK );
#endif
     return false;
   }
   pPacketInitPacket = (tPacketInitPacket*) GetProcAddress(hpacket, "PacketInitPacket");
   if (pPacketInitPacket == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketInitPacket", "Error", MB_OK );
#endif
     return false;
   }
   pPacketFreePacket = (tPacketFreePacket*) GetProcAddress(hpacket, "PacketFreePacket");
   if (pPacketFreePacket == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketFreePacket", "Error", MB_OK );
#endif
     return false;
   }
   pPacketReceivePacket = (tPacketReceivePacket*) GetProcAddress(hpacket, "PacketReceivePacket");
   if (pPacketReceivePacket == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketReceivePacket", "Error", MB_OK );
#endif
     return false;
   }
   pPacketSendPacket = (tPacketSendPacket*) GetProcAddress(hpacket, "PacketSendPacket");
   if (pPacketSendPacket == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketSendPacket", "Error", MB_OK );
#endif
     return false;
   }
   pPacketSetHwFilter = (tPacketSetHwFilter*) GetProcAddress(hpacket, "PacketSetHwFilter");
   if (pPacketSetHwFilter == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketSetHwFilter", "Error", MB_OK );
#endif
     return false;
   }
   pPacketRequest = (tPacketRequest*) GetProcAddress(hpacket, "PacketRequest");
   if (pPacketRequest == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketRequest", "Error", MB_OK );
#endif
     return false;
   }
   pPacketSetBuff = (tPacketSetBuff*) GetProcAddress(hpacket, "PacketSetBuff");
   if (pPacketSetBuff == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketSetBuff", "Error", MB_OK );
#endif
     return false;
   }
   pPacketSetBpf = (tPacketSetBpf*) GetProcAddress(hpacket, "PacketSetBpf");
   if (pPacketSetBpf == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketSetBpf", "Error", MB_OK );
#endif
     return false;
   }
   pPacketGetStats = (tPacketGetStats*) GetProcAddress(hpacket, "PacketGetStats");
   if (pPacketGetStats == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketGetStats", "Error", MB_OK );
#endif
     return false;
   }
   pPacketGetNetType = (tPacketGetNetType*) GetProcAddress(hpacket, "PacketGetNetType");
   if (pPacketGetNetType == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketGetNetType", "Error", MB_OK );
#endif
     return false;
   }
   pPacketSetReadTimeout = (tPacketSetReadTimeout*) GetProcAddress(hpacket, "PacketSetReadTimeout");
   if (pPacketSetReadTimeout == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketSetReadTimeout", "Error", MB_OK );
#endif
     return false;
   }
   pPacketSetMode = (tPacketSetMode*) GetProcAddress(hpacket, "PacketSetMode");
   if (pPacketSetMode == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketSetMode", "Error", MB_OK );
#endif
     return false;
   }
   pPacketSetNumWrites = (tPacketSetNumWrites*) GetProcAddress(hpacket, "PacketSetNumWrites");
   if (pPacketSetNumWrites == NULL)
   {
#ifdef _DEBUG
     MessageBox(NULL, "Can't load PacketSetNumWrites", "Error", MB_OK );
#endif
     return false;
   }
   return true;
}


